/* Legyen egy n elem (3 <= n <= 100 000), klnbz termszetes szmokat tartalmaz sorozat 
s az S termszetes szm. 
Vlasszunk ki az adott sorozatbl hrom elemet, amelyeknek az sszege S! 
Adjunk meg minden megoldst!
*/

#include <iostream>

using namespace std;

int binarisKereses(int bal, int jobb, int n, int x[], int keresett){
	
	int kozep;
	if(bal > jobb)
		return -1;
	else{
		kozep = ((bal + jobb) / 2);	
		if(keresett < x[kozep])
			return binarisKereses(bal, kozep - 1, n, x, keresett);
		else{	
			if(keresett > x[kozep])
				return binarisKereses(kozep + 1, jobb, n, x, keresett);
			else
				return kozep;
		}
	}
}

void general(int i, int n, int a[], int S){

	int k = (n + i) / 2;									// az a sorozat aktulis rsznek kzepe 
	while(i < n && a[i] < S){								// nem rdemes S-nl nagyobb a[i]-vel dolgozni 
		int j = i + 1;										// a msodik tag indexe 
		while(j <= n && (a[i] + a[j] < S)){					// nem rdemes S-nl nagyobb a[i] + a[j]-vel dolgozni 
			k = binarisKereses(j + 1, n, n, a, S - a[i] - a[j]);
															// k = az S - a[i] - a[j] (hinyz tag) indexe
			if(k != -1)										// ha talltunk ilyen rtket
				cout << a[i] <<" + " << a[j] << " + " << a[k] << endl;	
			j++;
		}		
		i++;
	}
}

int main(){
	int a[] = {0, 1, 2, 3, 5, 7, 8, 9, 10};
	int n = 8;
	int S;
	
	cout << "osszeg = (peldaul 12) = "; cin >> S;
	general(1, n, a, S);	
}
