/* Számoljuk meg egy n (1 <= n <= 1 000 000) elemû sorozat négyzetszámait! 
A számok nem nagyobbak 1 000 000-nál.
*/

#include <iostream>

using namespace std;

int teljesNegyzetSzamlalo(int n, int a[]){

	int p = 0;								// a négyzetszámok darabszáma
	for(int i = 1; i <= n; i++){			// bejárjuk a sorozatot
		int eleje = 1;						// négyzetgyök(szám) első lehetséges értéke
		int vege = 1000;					// négyzetgyök(szám) utolsó lehetséges értéke
		int szam = a[i];
		while(eleje < vege){
			int k = (eleje + vege) / 2;
			if(k * k >= szam)
				vege = k;
			else
				eleje = k + 1;
		}
		
		if(eleje * eleje == szam){
			// cout<< szam <<endl;
			p++;
		}
	}
	return p;
}

int main(){
	int x[] = {
		0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,
		  11,12,13,14,15,16,17,18,19,20,
		  21,22,23,24,25,26,27,28,29,30,
		  31,32,33,34,35,36,37,38,39,40,
		  41,42,43,44,45,46,47,48,49,50,
		  51,52,53,54,55,56,57,58,59,60,
		  61,62,63,64,65,66,67,68,69,70,
		  71,72,73,74,75,76,77,78,79,80,
		  81,82,83,84,85,86,87,88,89,90,
		  91,92,93,94,95,96,97,98,99,100
	};
	int n = 100;
	cout << "Negyzetekszamok darabszama a sorozatban = " << teljesNegyzetSzamlalo(n, x) << endl;
}
