/* Adott egy n egsz szmbl ll, nvekv sorrendbe rendezett sorozat: x[1] < x[2] <...< x[n]. 
llaptsuk meg egy adott szm helyt a sorozatban! Ha az illet szm nem tallhat meg 
a sorozatban, rjunk ki egy megfelel zenetet!
*/

#include <iostream>

using namespace std;

void kiir(int n, int x[]){

	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

int binarisKeresesIterativan(int bal, int jobb, int n, int x[], int keresett){
		
	while(bal <= jobb){
		int kozep = (bal + jobb) / 2;
		if(x[kozep] == keresett)
			return kozep;
		else{
			if(x[kozep] > keresett)
				jobb = kozep - 1;
			else
				bal = kozep + 1;
		}	
	}
	return -1;
}

int main(){
	int x[] = {0, 1, 4, 6, 8, 12, 34, 56, 78, 102, 123};
	int n = 10;
	kiir(n, x);
	
	int keresett;
	cout << "keresett = "; cin >> keresett;

	int er = binarisKeresesIterativan(1, n, n, x, keresett);	
	if(er != -1)
		cout << "A keresett szam a " << er << ". indexen talalhato." << endl;
	else
		cout << "A keresett szam nincs a sorozatban!" << endl;
}
