/* Kt fggleges fal egymstl t tvolsgra tallhat. 
Egy h1 hosszsg deszkt az egyik fal alapjtl a msik falnak tmasztunk. 
Egy h2 hosszsg deszkt a msik fal alapjtl az els falnak tmasztunk. 
A kt deszka m magassgban rinti egymst egy pontban, amely valahol a kt fal kztt tallhat. 
Szmtsuk ki t-t h1, h2 s m ismeretben (megengedett hibalehetsg 10^(-5)). 
*/

#include <iostream>
#include <cmath>

using namespace std;

void szamol(double h1, double h2, double t, double & sz){

	double x = sqrt((h1 * h1) - (t * t));
	double y = sqrt((h2 * h2) - (t * t));
	sz = ((x * y) / (x + y));
}

double deszkak(double m, double h1, double h2){

	double sz, t;
	bool megvan = false;	

	if(h1 > h2)
		t = h2;
	else
		t = h1;
	double min = 0, max = t;	// t = a rvidebb deszka hossza
	while(!megvan){
		t = (min + max) / 2;	// a lehetsges rtk kzepe
		szamol(h1, h2, t, sz);	// sz = a magassg, ahol most tallkozik a kt deszka
		
		if(abs(sz - m) <= 0.00001)// vizsgljuk a kvetelmnyt
			megvan = true;
		else{					// ha mg nem elg j az eredmny
			if(sz > m)
				min = t;		// sszenyomjuk a kt falat
			else
				max = t;		// szthzzuk a kt falat
		}
	}
	return t;
}

int main(){
	
	double h1 = 7;
	double h2 = 10;
	double m = 3;
	
	double t = deszkak(m, h1, h2);
	cout << "Tavolsag = " << t << endl;
}
